/*
 * 
 * gsasm.c - This is the main file, used to read in options and file names
 *
 * Kris Bahnsen  <kbahnsen@gmail.com>
 * Copyright (C) 2007 Kris Bahnsen
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 */


#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#include "gsasm.h"

#define GETOPT(ac,av,opt,lopt) getopt_long(ac,av,opt,lopt,NULL)
#define TRUE 1
#define FALSE 0


int main(int argc, char** argv)
{
	int c;


	asm_file_in = hex_file_out = argv[(argc - 1)];
	while ((c = getopt(argc, argv,"HAha")) != EOF)
	{
		
		switch(c)
		{
			case 'H':
			case 'h':
				printusage();
				break;
			case 'A':
			case 'a':
				read_asm((char *)asm_file_in);
				fcloseall();
				break;
			default:
				
				printusage();
				break;
		}
		
	}
	if(argc == 1) printusage();
	
	
	
	return 0;
}

int printusage(void)
{
	fprintf(stderr, "Usage: gsasm [-a [source file]]\n");
	fprintf(stderr, "-a	Assemble source file\n");
	fprintf(stderr, "-h	This explanation\n\n");
	fprintf(stderr, "Usable hexfile is [source file].hex\n");
	exit(1);
}

